<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getPageMetadata } from '../common/meta';
import {
  SolutionsHero,
  SolutionsVideoModal,
} from '../components/solutions/index.vue';
import SupportCopyMarkdownServices from '../components/support/copy-markdown-services.vue';
import ServicesForm from '../components/services/form.vue';
import { CONTENT_TYPES } from '../common/content-types';
import { getClient } from '../plugins/contentful';

export default Vue.extend({
  components: {
    ServicesForm,
    SupportCopyMarkdownServices,
    SolutionsHero,
    SolutionsVideoModal,
  },
  nuxtI18n: false,
  async asyncData({ error }: any) {
    try {
      const { items } = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'fields.slug': 'services',
        include: 10,
      });

      const data = items[0].fields.pageContent;
      const metadata = items[0].fields.seoMetadata[0].fields;

      const content = { ...metadata } as any;
      const [
        hero,
        sideNavigation,
        implementation,
        migration,
        advisory,
        acceleration,
        education,
        form,
      ] = data;
      //  Data mapping

      //  Hero

      content.hero = {
        title: hero.fields.title,
        subtitle: hero.fields.description,
        primary_btn: {
          url: hero.fields.primaryCta.fields.externalUrl,
          text: hero.fields.primaryCta.fields.text,
          data_ga_name: hero.fields.primaryCta.fields.dataGaName,
          data_ga_location: hero.fields.primaryCta.fields.dataGaLocation,
        },
        image: {
          bordered: true,
          image_url: hero.fields.backgroundImage.fields.file.url,
          alt: hero.fields.backgroundImage.fields.title,
        },
      };

      //  Side Navigation

      content.side_menu = {
        anchors: {
          text: sideNavigation.fields.header,
          data: sideNavigation.fields.anchors.map((anchor: any) => ({
            text: anchor.fields.linkText,
            href: anchor.fields.anchorLink,
          })),
        },
        ...sideNavigation.fields.customFields,
      };

      // copy blocks
      const blocks = [
        implementation,
        migration,
        advisory,
        acceleration,
        education,
      ];
      content.blog_copy = {
        block: blocks.map((block: any) => ({
          header: block.fields.header,
          id: block.fields.headerAnchorId,
          ...block.fields.customFields,
        })),
      };

      // Form
      content.form_block = {
        id: 'contactform',
        header: form.fields.header,
        form: {
          form_id: form.fields.formId,
          datalayer: 'services',
        },
      };

      return { content };
    } catch (e) {
      error({ statusCode: 404 });
      return {};
    }
  },
  data() {
    return {
      showModal: false,
    };
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).content, this.$route.path);
  },
  methods: {
    openModal() {
      this.showModal = true;
    },
  },
});
</script>

<template>
  <section class="services">
    <SolutionsHero :data="content.hero" />
    <SlpContainer>
      <SlpSideNavigation :data="content.side_menu" class="services__navigation">
        <template #header>
          <div class="services__nav-buttons">
            <SlpButton
              v-for="(button, buttonIndex) in content.side_menu.hyperlinks.data"
              :key="buttonIndex"
              :variant="button.variant"
              :href="button.href"
              :data-ga-name="button.data_ga_name"
              :data-ga-location="button.data_ga_location"
              @click.native="button.modal && openModal()"
              >{{ button.text }}
              <SlpIcon
                v-if="button.icon"
                class="slp-ml-8"
                :name="button.icon.name"
                :variant="button.icon.variant"
                alt="Icon"
              />
            </SlpButton>
          </div>
        </template>
        <SlpRow>
          <SlpColumn :cols="11">
            <SupportCopyMarkdownServices :data="content.blog_copy" />
          </SlpColumn>
        </SlpRow>
      </SlpSideNavigation>
      <SlpSideButton
        data-ga-name="to-top"
        data-ga-location="body"
        class="services__to-top"
      />
    </SlpContainer>
    <SlpContainer variant="gradient" class="slp-pb-96">
      <ServicesForm :data="content.form_block"></ServicesForm>
    </SlpContainer>
    <SolutionsVideoModal
      v-show="showModal"
      light-background
      :visible="showModal"
      @close="showModal = false"
    >
      <!-- <template #body>
        <iframe
          :src="doc.hero.modal_src"
          title="Video player"
          allow="accelerometer; clipboard-write; encrypted-media; gyroscope; picture-in-picture"
          allowfullscreen
        ></iframe>
      </template> -->
    </SolutionsVideoModal>
  </section>
</template>

<style scoped lang="scss">
.services {
  &__nav-buttons {
    width: 100%;
    margin-bottom: $spacing-24;

    .slp-btn {
      width: 100%;
      justify-content: center;
      margin-bottom: $spacing-8;
    }

    .slp-btn-secondary {
      padding: 11px 0;
    }
  }

  &__to-top {
    display: none;

    @media (min-width: $breakpoint-md) {
      display: inherit;
    }
  }

  &__navigation {
    &:deep(.dropdown) {
      margin: $spacing-32 0;
    }
  }
}
</style>
